#include <time.h>                      // define time()
#include <stdio.h>
#include <stdlib.h>
#include "../RandGens/randomc.h"                   // define classes for random number generators
#include "../RandGens/userintf.cpp"                // define system specific user interface

// include code for one of the random number generators:
// #include "mersenne.cpp"                // members of class TRandomMersenne
// or:
// #include "ranrotw.cpp"              // members of class TRanrotWGenerator
// or:
#include "../RandGens/mother.cpp"               // members of class TRanrotWGenerator

int main(int argc, char **argv) {
  int32 seed = time(0);                // random seed
  
  // choose one of the random number generators:
  // TRandomMersenne rg(seed);            // make instance of random number generator
  // or:
  // TRanrotWGenerator rg(seed);       // make instance of random number generator
  // or:
  TRandomMotherOfAll rg(seed);      // make instance of random number generator
  
  int i,j;                               // loop counter
  double r;                            // random number
  int32 ir;                            // random integer number
  int32 numValsPerLine, maxVal, numLines;

  if (argc < 3) {
      printf("Usage: %s <maxVal> <numValsPerLine> <numLines> \n", argv[0]);
      exit(0);
  }

  maxVal = atoi(argv[1]);
  numValsPerLine = atoi(argv[2]);
  numLines = atoi(argv[3]);

  // make random integers in interval from 0 to 99, inclusive:
  printf("\n\nRandom integers in interval from 0 to %d:\n", maxVal);
  for (i=0; i<numLines; i++) {
      for (j = 0; j < numValsPerLine; j++) {
          ir = rg.IRandom(0,maxVal);
          printf ("%6li  ", ir);
      }
      printf("\n");
  }
}


