
/**

PROJECT:	CS 298 Deliverable

FILE:		Timer.java

PURPOSE:	Times runs

@author Aarathi Raghu

@version	10/06/2006

@since Java  1.4.2

*/

import java.util.*;
import java.lang.*;
import java.io.*;
import java.lang.Object.*;

public class ItemSetInfo
{
	/* tracks the columns for which this set corresponds to */
	public ByteClass colNums;
	/* attribute values for this set: we have one such for each unique value in the column */
	public ArrayList[] attributeValue;
	/* row bit map that tracks the rows in which attributes in attributeValue occur */
	public ByteClass[] rowBitmap;
	public int currRow, numRows;
	
	/**
	Constructor
	@param colNums: Column for which this set corresponds to
	@param nRows: # of rows in which the item in the column occurs.
	*/
	public ItemSetInfo(ByteClass colNums, int nRows) {
		this.colNums = (ByteClass) colNums.clone();
		this.numRows = nRows;
		this.attributeValue = new ArrayList[nRows];
		this.rowBitmap = new ByteClass[nRows];
		currRow = 0;
	}

	/**
	Add a new row of attribute values.
	@param attrVal: The list of attribute values
	@param rowInfo: The row in which attribute values occur.
	*/
	public void addNewRow(ArrayList attrVal, ByteClass rowInfo) {
		Iterator iter = attrVal.iterator();
		attributeValue[currRow] = new ArrayList();
		while (iter.hasNext()) {
			Integer attr = (Integer) iter.next();
			attributeValue[currRow].add(new Integer(attr.intValue()));
		}
		rowBitmap[currRow] = (ByteClass) rowInfo.clone();
		currRow++;
	}
};

