/**
PROJECT:	CS 298 Deliverable

FILE:		ReadFile.java

PURPOSE:	Read a file of data for input to the algorithm.

@author 	Aarathi Raghu

@version	12/06/2006

@since 		Java 1.4.2
*/


import java.io.*;
import java.lang.Object.*;
import java.util.*;
import java.lang.*;
public class ReadFile 
{
		
		/**
		 Read data from an input file.  For reading data, read data from disk into a buffer.  The
		 buffered data can  be used to satisfy subsequent read requests
		 @param filename:  The file containing data to be read in
		 @retval Returns data read segmented row-by-row.
		*/
		public  int[][] readFromFile(String filename) throws Exception
		{
			int table[][]= new int[150][150];
			String text;
			BufferedReader br = null;
			char bufPage[] = new char[4096];
			int bufPageSize = 4096;
			int bufPageStartOff = 0;
			int max_cols = 100;
			
			try
			{
				System.out.println("reading file :" + filename );

				FileReader fr = new FileReader(filename);
				br = new BufferedReader(fr);
				int rowcount = 0, colcount = 0;
				int nread, nbytesInBuf;
				
				while (true) 
				{
					// Read a page at a time.
					nread = br.read(bufPage, bufPageStartOff, bufPageSize - bufPageStartOff);
					if (nread < 0) 
						break;
					
					char ch;
					int curPos = 0; // buffer is filled from 0 to nread...
					boolean gotInt = false;
					
					// What we have in the buffer is what we just read and anything leftover from a previous read
					nbytesInBuf = nread + bufPageStartOff;
					// Extract integer by integer
					while (curPos < nbytesInBuf) 
					{
						String intVal = "";
						gotInt = false;
						// Extract an integer
						while (curPos < nbytesInBuf) 
						{
							ch = bufPage[curPos];
							curPos++;
							if ((ch == ' ') || (ch == '\n')) 
							{
								if (intVal != "")
									gotInt = true;
								break;
							}
							intVal = intVal + ch;
							// System.out.println("Read in: " + ch);
						}
						if (!gotInt) 
						{
							// reset curPos to reflect the char's we didn't consume
							curPos = bufPageStartOff;
							break;
						}
						bufPageStartOff = curPos;
						if (colcount < max_cols) 
						{
							table[rowcount][colcount] = Integer.parseInt(intVal, 10) ;
							// System.out.println("table[" + rowcount + "][" + colcount + "] = " + table[rowcount][colcount]);
							colcount++;
						}
						if (colcount >= max_cols) 
						{
							// System.out.println("-------\n");
							rowcount++;
							colcount = 0;
						}
					}
					// shift things over in case we read part of an integer
					for (bufPageStartOff = 0; curPos < nbytesInBuf; curPos++,bufPageStartOff++) 
					{
						bufPage[bufPageStartOff] = bufPage[curPos];
					}
				}
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
			br.close();
			return table;
	}
}
