/**

PROJECT:                CS 297 Deliverable 3

FILE:                   lattice.java

PURPOSE:                The driver class for this deliverable.

@author  Aarathi Raghu

@version        12/05/2005

@since  Java 1.4.2


*/
import java.util.*;

public class lattice 
{

    public static void main (String args[]) 
    {
	
		if (args.length < 4) 
		{
			System.out.println("Usage: lattice <inputFile> <minSup> <numLines><numColumns>");
			return;
		}
		String inputFile = args[0];
		int minSup = Integer.parseInt(args[1]);
		int numLines = Integer.parseInt(args[2]);
		int numColumns = Integer.parseInt(args[3]);
		System.out.println("Read file: " + inputFile);
		Timer timer = new Timer();

		try
		{
			AttrValLattice avl = new AttrValLattice(numColumns);
			avl.MakeBitmap(inputFile, numLines);
			avl.MakeNodes(minSup);
			avl.CombineNodes(minSup);
			// avl.PrintNodes(avl.sortedNodeSet);
			timer.startTiming("Time for finding closed frequent itemsets");
			avl.FindClosedFrequentItemsets(minSup);
			timer.stopTiming();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
    }
}
