#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <strings.h>

#define MAX_VALS 131072
int main(int argc, char **argv)
{
    FILE *ifp;
    char *spc;
    int hist[MAX_VALS];
    int i, col, val;
    int histBinWidth;
    char lineStr[1024];

    if (argc < 2) {
        printf("Usage: %s <input file> <col> <histBinWidth> \n", argv[0]);
        exit(0);
    }

    if ((ifp = fopen(argv[1], "r")) == NULL) {
        printf("%s doesn't exist\n", argv[1]);
        exit(0);
    }

    if (argc == 4)
	histBinWidth = atoi(argv[3]);
    else
	histBinWidth = 1;

    memset(hist, 0, MAX_VALS * sizeof(int));

    col = atoi(argv[2]);
    while (!feof(ifp)) {
        if (fgets(lineStr, 512, ifp) == NULL)
            break;
	spc = lineStr;
	for (i = 0; i < col; i++) {
	  spc = index(spc, ' ');
	  ++spc;
	}
	val = atoi(spc);
	hist[val / histBinWidth]++;
    }
    for (i = 0; i < MAX_VALS; i++) {
      if (hist[i] != 0) {
	printf("%d %d\n", i, hist[i]);
      }
    }
}
